local L = AceLibrary("AceLocale-2.2"):new("wf3sec")
local waterfall = AceLibrary:HasInstance("Waterfall-1.0") and AceLibrary("Waterfall-1.0") or nil
local options ={}
local xres, yres = 0,0;

function wf3sec:RegisterOpts()
	local xyres=GetCVar("gxResolution");
	xres, yres=strsplit("x",xyres);
	xres=tonumber(xres);
	yres=tonumber(yres);
	
	options = { 
	    type='group',
	    args = {
			lost = {
	            type = 'execute',
	            name = 'Lost SS',
	            desc = 'Shows Lost SS',
				func  = function()
					DEFAULT_CHAT_FRAME:AddMessage(self.lostss.." are lost because of wrong timing of SS");
			    end
	        },
			resetlost = {
	            type = 'execute',
	            name = 'Lost SS reset',
	            desc = 'Reset Lost SS',
				func  = function()
					self.lostss=0;
			    end
	        },
	        x = {
	            type = 'range',
	            name = 'Main x',
	            desc = 'Change X coord of Main timer',
	            min = (-1)*xres/2,
				max = xres/2,
				step = 1,
				get = function()
			        return wf3sec.db.profile.x
			    end,
	            set = function(v)
			        wf3sec.db.profile.x=v;
					self:GroupsSET();
					self:TestBars();
			    end
	        },
			y = {
	            type = 'range',
	            name = 'Main y',
	            desc = 'Change Y coord of Main timer',
	            min = (-1)*yres/2,
				max = yres/2,
				step = 1,
				get = function()
			        return wf3sec.db.profile.y
			    end,
	            set = function(v)
			        wf3sec.db.profile.y=v;
					self:GroupsSET();
					self:TestBars();
			    end
	        },
			scale = {
	            type = 'range',
	            name = 'Main scale',
	            desc = 'Change Scale of Main timer',
	            min = 0.3,
				max = 3,
				step = 0.1,
				get = function()
			        return wf3sec.db.profile.scale
			    end,
	            set = function(v)
			        wf3sec.db.profile.scale=v;
					self:GroupsSET();
					self:TestBars();
			    end
	        },
	        xs = {
	            type = 'range',
	            name = 'Secondary x',
	            desc = 'Change X coord of Secondary timer',
	            min = (-1)*xres/2,
				max = xres/2,
				step = 1,
				get = function()
			        return wf3sec.db.profile.xgcd
			    end,
	            set = function(v)
			        wf3sec.db.profile.xgcd=v;
					self:GroupsSET();
					self:TestBars();
			    end
	        },
			ys = {
	            type = 'range',
	            name = 'Secondary y',
	            desc = 'Change Y coord of Secondary timer',
	            min = (-1)*yres/2,
				max = yres/2,
				step = 1,
				get = function()
			        return wf3sec.db.profile.ygcd
			    end,
	            set = function(v)
			        wf3sec.db.profile.ygcd=v;
					self:GroupsSET();
					self:TestBars();
			    end
	        },
			 xmw = {
	            type = 'range',
	            name = 'Maelstrom Weapon x',
	            desc = 'Change X coord of Maelstrom Weapon counter',
	            min = (-1)*xres/2,
				max = xres/2,
				step = 1,
				get = function()
			        return wf3sec.db.profile.xmw
			    end,
	            set = function(v)
			        wf3sec.db.profile.xmw=v;
					wf3sec.f:SetPoint("CENTER", "UIParent", "CENTER",wf3sec.db.profile.xmw,wf3sec.db.profile.ymw);
--					self:MSFrameSET();
					self:TestMW();
					self:TestBars();
			    end
	        },
			ymw = {
	            type = 'range',
	            name = 'Maelstrom Weapon y',
	            desc = 'Change Y coord of Maelstrom Weapon counter',
	            min = (-1)*yres/2,
				max = yres/2,
				step = 1,
				get = function()
			        return wf3sec.db.profile.ymw
			    end,
	            set = function(v)
			        wf3sec.db.profile.ymw=v;
					wf3sec.f:SetPoint("CENTER", "UIParent", "CENTER",wf3sec.db.profile.xmw,wf3sec.db.profile.ymw);
--					self:MSFrameSET();
					self:TestMW();
					self:TestBars();
			    end
	        },
			scales = {
	            type = 'range',
	            name = 'Secondary scale',
	            desc = 'Change Scale of Secondary timer',
	            min = 0.3,
				max = 3,
				step = 0.1,
				get = function()
			        return wf3sec.db.profile.scalegcd
			    end,
	            set = function(v)
			        wf3sec.db.profile.scalegcd=v;
					self:GroupsSET();
					self:TestBars();
			    end
	        },

			showss = {
	            type = 'toggle',
	            name = 'Toggle SS',
	            desc = 'Show/Hide SS',
	            get = function()
			        return wf3sec.db.profile.showss
			    end,
	            set = function(v)
			        wf3sec.db.profile.showss=v;
					self:SScandySET();
					self:SSdcandySET();
					self:TestBars();
			    end,
				map = { [false] = "Disabled", [true] = "Enabled" }
	        },
			showshock = {
	            type = 'toggle',
	            name = 'Toggle Shocks',
	            desc = 'Show/Hide Shocks',
	            get = function()
			        return wf3sec.db.profile.showshock
			    end,
	            set = function(v)
			        wf3sec.db.profile.showshock=v;
					self:ShockcandySET();
					self:FlamecandySET();
					self:TestBars();
			    end,
				map = { [false] = "Disabled", [true] = "Enabled" }
	        },
			showsr = {
	            type = 'toggle',
	            name = 'Toggle SR',
	            desc = 'Show/Hide Rage',
	            get = function()
			        return wf3sec.db.profile.showsr
			    end,
	            set = function(v)
			        wf3sec.db.profile.showsr=v;
					self:SRcandySET();
					self:TestBars();
			    end,
				map = { [false] = "Disabled", [true] = "Enabled" }
	        },
			showll = {
	            type = 'toggle',
	            name = 'Toggle LL',
	            desc = 'Show/Hide Lava Lash',
	            get = function()
			        return wf3sec.db.profile.showll
			    end,
	            set = function(v)
			        wf3sec.db.profile.showll=v;
					self:LLcandySET();
					self:TestBars();
			    end,
				map = { [false] = "Disabled", [true] = "Enabled" }
	        },
			showmw = {
	            type = 'toggle',
	            name = 'Toggle MW',
	            desc = 'Show/Hide Maelstrom Weapon',
	            get = function()
			        return wf3sec.db.profile.showmw
			    end,
	            set = function(v)
			        wf3sec.db.profile.showmw=v;
					if (wf3sec.db.profile.showmw) then 
						wf3sec.f:Show();
					else 
						wf3sec.f:Hide();
					end
--					self:MSFrameSET();
					self:TestMW();
			    end,
				map = { [false] = "Disabled", [true] = "Enabled" }
	        },
			showgcd = {
	            type = 'toggle',
	            name = 'Toggle GCD',
	            desc = 'Show/Hide GCD',
	            get = function()
			        return wf3sec.db.profile.showgcd;
			    end,
	            set = function(v)
			        wf3sec.db.profile.showgcd=v;
					self:SecondCandySET();
					self:TestBars();
			    end,
				map = { [false] = "Disabled", [true] = "Enabled" }
	        },
			length = {
	            type = 'toggle',
	            name = 'Resize Main Bars',
	            desc = '10secs/Small Main Bars',
	            get = function()
			        return wf3sec.db.profile.tensec;
			    end,
	            set = function(v)
			        wf3sec.db.profile.tensec=v;
					self:WFcandySET();
					self:LLcandySET();
					self:ShockcandySET();
					self:TestBars();
			    end,
				map = { [false] = "Small", [true] = "10sec" }
	        },
			showwf = {
	            type = 'toggle',
	            name = 'Toggle WF',
	            desc = 'Show/Hide WF as another bar',
	            get = function()
			        return wf3sec.db.profile.showwf
			    end,
	            set = function(v)
			        wf3sec.db.profile.showwf=v;
					self:WFcandySET();
					self:TestBars();
			    end,
				map = { [false] = "Disabled", [true] = "Enabled" }
	        },
			gui = {
				name = "WF3sec",
				desc = "Enhancement Shaman Timer Mod by Hed",
				type = "execute",
				guiHidden = true,
--				order = 17,
				func =  function()
					waterfall:Open("WF3sec")
				end,
				hidden = function() return not waterfall end,
			},
	    }
	}
	self:RegisterChatCommand("/wf3sec", "/WF3sec", options);
	if waterfall then
		waterfall:Register(
			"WF3sec",
			"aceOptions", options,
			"colorR", .6, "colorG", .5, "colorB", .8
		)
	end
end