local L = AceLibrary("AceLocale-2.2"):new("wf3sec")

wf3sec = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "CandyBar-2.0","AceDB-2.0" )
local playerName=UnitName("player");
local version, build, date = GetBuildInfo();
local release = tonumber(string.sub(version,0,1));

function wf3sec:OnInitialize()
	local defaults = {
		x=0,
		y=-40,
		xgcd=0,
		ygcd=-100,
		scale=0.6,
		scalegcd=0.6,
		xmw=40,
		ymw=-30,
		xs=80,
		ys=-30,
		showss=true,
		showll=true,
		showshock=true,
		showsr=true,
		showwf=false,
		showgcd=true,
		showmw=true,
		showferal=true,
		tensec=true,
		showmt=true
	}

	wf3sec:RegisterDB("WF3secDB");
	wf3sec:RegisterDefaults("profile", defaults);
--	self:getscreenres();
	self:RegisterOpts();

	self.numwf=0;
	self.lastwf=0;
	self.lastss=0;
	self.lostss=0;
	self.inflame=false;

	self.wfid=nil;
	self.wftexture=" ";
	self.ssid=nil;
	self.sstexture=" ";
	self.gcdid=nil;
	self.gcdtexture=" ";
	self.srsid=nil;
	self.srtexture=" ";
	self.esid=nil;
	self.estexture=" ";
	self.fsid=nil;
	self.fstexture=" ";
	self.llid=nil;
	self.lltexture=" ";
	self.feralid=nil;
	self.feraltexture=" ";
	self.mtid=nil;
	self.mtexture=" ";
end

function wf3sec:OnEnable()
	self:regWF();
	self:regMW();
	self:TestBars();
end

function wf3sec:regWF()
	for i = 1, MAX_SKILLLINE_TABS do
		local name, texture, offset, numSpells = GetSpellTabInfo(i);
		if not name then
			break;
		end
		for s = offset + 1, offset + numSpells do
	    	local spell, rank = GetSpellName(s, BOOKTYPE_SPELL);
			if (spell==L["Windfury Weapon"]) then
				self.wfid=s;
				self.wftexture=GetSpellTexture(s,BOOKTYPE_SPELL);
			elseif (spell==L["Stormstrike"]) then
				self.ssid=s;
				self.sstexture=GetSpellTexture(s,BOOKTYPE_SPELL);
			elseif (spell==L["Far Sight"]) then
				self.gcdid=s;
				self.gcdtexture=GetSpellTexture(s,BOOKTYPE_SPELL);
			elseif (spell==L["Shamanistic Rage"]) then
				self.srid=s;
				self.srtexture=GetSpellTexture(s,BOOKTYPE_SPELL);
			elseif (spell==L["Earth Shock"]) then
				self.esid=s;
				self.estexture=GetSpellTexture(s,BOOKTYPE_SPELL);
			elseif (spell==L["Flame Shock"]) then
				self.fsid=s;
				self.fstexture=GetSpellTexture(s,BOOKTYPE_SPELL);
			elseif (spell==L["Lava Lash"]) then
				self.llid=s;
				self.lltexture=GetSpellTexture(s,BOOKTYPE_SPELL);
			elseif (spell==L["Feral Spirit"]) then
				self.feralid=s;
				self.feraltexture=GetSpellTexture(s,BOOKTYPE_SPELL);
			elseif (spell==L["Magma Totem"]) then
				self.mtid=s;
				self.mttexture=GetSpellTexture(s,BOOKTYPE_SPELL);
			end
		end
	end
	if (self.wfid and self.ssid) then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
		self:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
		self:GroupsSET();
	end
end

function wf3sec:GroupsSET()
	if (self:IsCandyBarGroupRegistered("MainCandy")) then
		if (self:IsCandyBarRegistered("WFcandyBAR")) then
			self:StopCandyBar("WFcandyBAR");
			self:UnregisterCandyBar("WFcandyBAR");
		end
		if (self:IsCandyBarRegistered("SScandyBAR")) then
			self:StopCandyBar("SScandyBAR");
			self:UnregisterCandyBar("SScandyBAR");
		end
		if (self:IsCandyBarRegistered("SRcandyBAR")) then
			self:StopCandyBar("SRcandyBAR");
			self:UnregisterCandyBar("SRcandyBAR");
		end
		if (self:IsCandyBarRegistered("ShockcandyBAR")) then
			self:StopCandyBar("ShockcandyBAR");
			self:UnregisterCandyBar("ShockcandyBAR");
		end
		if (self:IsCandyBarRegistered("LLcandyBAR")) then
			self:StopCandyBar("LLcandyBAR");
			self:UnregisterCandyBar("LLcandyBAR");
		end
		if (self:IsCandyBarRegistered("FeralcandyBAR")) then
			self:StopCandyBar("FeralcandyBAR");
			self:UnregisterCandyBar("FeralcandyBAR");
		end
		if (self:IsCandyBarRegistered("MTcandyBAR")) then
			self:StopCandyBar("MTcandyBAR");
			self:UnregisterCandyBar("MTcandyBAR");
		end
		self:UnregisterCandyBarGroup("MainCandy");
	end
	
	self:RegisterCandyBarGroup("MainCandy");
	self:SetCandyBarGroupPoint("MainCandy", "CENTER", "UIParent", "CENTER",wf3sec.db.profile.x/wf3sec.db.profile.scale,wf3sec.db.profile.y/wf3sec.db.profile.scale);
	self:WFcandySET();
	self:SScandySET();
	self:SRcandySET();
	self:ShockcandySET();
	self:LLcandySET();
	self:FeralcandySET();
	self:MTcandySET();
	
	if (self:IsCandyBarGroupRegistered("SecondCandy")) then
		if (self:IsCandyBarRegistered("GCDBAR")) then
			self:StopCandyBar("GCDBAR");
			self:UnregisterCandyBar("GCDBAR");
		end
		if (self:IsCandyBarRegistered("FlamecandyBAR")) then
			self:StopCandyBar("FlamecandyBAR");
			self:UnregisterCandyBar("FlamecandyBAR");
		end
		if (self:IsCandyBarRegistered("SSdcandyBAR")) then
			self:StopCandyBar("SSdcandyBAR");
			self:UnregisterCandyBar("SSdcandyBAR");
		end
		self:UnregisterCandyBarGroup("SecondCandy");
	end
	self:RegisterCandyBarGroup("SecondCandy");
	self:SetCandyBarGroupPoint("SecondCandy", "CENTER", "UIParent", "CENTER",wf3sec.db.profile.xgcd/wf3sec.db.profile.scalegcd,wf3sec.db.profile.ygcd/wf3sec.db.profile.scalegcd);
	self:SecondCandySET();
	self:FlamecandySET();
	self:SSdcandySET();
end

function wf3sec:WFcandySET()
	if (self:IsCandyBarRegistered("WFcandyBAR")) then
		self:StopCandyBar("WFcandyBAR");
		self:UnregisterCandyBar("WFcandyBAR");
	end
	if (wf3sec.db.profile.showwf and self.wfid) then
		if (wf3sec.db.profile.tensec) then
			self:RegisterCandyBar("WFcandyBAR",10,"WF 3 sec cooldown",self.wftexture);
		else
			self:RegisterCandyBar("WFcandyBAR",3,"WF 3 sec cooldown",self.wftexture);
		end
		self:SetCandyBarColor("WFcandyBAR","green",0.5);
		self:SetCandyBarScale("WFcandyBAR", wf3sec.db.profile.scale);
		self:RegisterCandyBarWithGroup("WFcandyBAR","MainCandy");
	end
end

function wf3sec:TestBars()
	if (self:IsCandyBarRegistered("WFcandyBAR") and wf3sec.db.profile.showwf and self.wfid) then
		self:StopCandyBar("WFcandyBAR");
		self:SetCandyBarTimeLeft("WFcandyBAR",3);
		self:StartCandyBar("WFcandyBAR");
	end
	if (self:IsCandyBarRegistered("SScandyBAR") and wf3sec.db.profile.showss and self.ssid) then
		self:StopCandyBar("SScandyBAR");
		self:SetCandyBarTimeLeft("SScandyBAR",10);
		self:StartCandyBar("SScandyBAR");
	end
	if (self:IsCandyBarRegistered("LLcandyBAR") and wf3sec.db.profile.showll and self.llid) then
		self:StopCandyBar("LLcandyBAR");
		self:SetCandyBarTimeLeft("LLcandyBAR",6);
		self:StartCandyBar("LLcandyBAR");
	end
	if (self:IsCandyBarRegistered("FeralcandyBAR") and wf3sec.db.profile.showferal and self.feralid) then
		self:StopCandyBar("FeralcandyBAR");
		self:SetCandyBarTimeLeft("FeralcandyBAR",10);
		self:StartCandyBar("FeralcandyBAR");
	end
	if (self:IsCandyBarRegistered("SRcandyBAR") and wf3sec.db.profile.showsr and self.srid) then
		self:StopCandyBar("SRcandyBAR");
		self:SetCandyBarTimeLeft("SRcandyBAR",10);
		self:StartCandyBar("SRcandyBAR");
	end
	if (self:IsCandyBarRegistered("ShockcandyBAR") and wf3sec.db.profile.showshock and self.esid) then
		self:StopCandyBar("ShockcandyBAR");
		self:SetCandyBarTimeLeft("ShockcandyBAR",6);
		self:StartCandyBar("ShockcandyBAR");
	end
	if (self:IsCandyBarRegistered("FlamecandyBAR") and wf3sec.db.profile.showshock and self.fsid) then
		self:StopCandyBar("FlamecandyBAR");
		self:SetCandyBarTimeLeft("FlamecandyBAR",12);
		self:StartCandyBar("FlamecandyBAR");
	end
	if (self:IsCandyBarRegistered("GCDBAR") and wf3sec.db.profile.showgcd and self.gcdid) then
		self:StopCandyBar("GCDBAR");
		self:SetCandyBarTimeLeft("GCDBAR",1.5);
		self:StartCandyBar("GCDBAR");
	end
	if (self:IsCandyBarRegistered("SSdcandyBAR") and wf3sec.db.profile.showss and self.ssid) then
		self:StopCandyBar("SSdcandyBAR");
		self:SetCandyBarTimeLeft("SSdcandyBAR",12);
		self:StartCandyBar("SSdcandyBAR");
	end
	if (self:IsCandyBarRegistered("MTcandyBAR") and wf3sec.db.profile.showmt and self.mtid) then
		self:StopCandyBar("MTcandyBAR");
		self:SetCandyBarTimeLeft("MTcandyBAR",20);
		self:StartCandyBar("MTcandyBAR");
	end
end

function wf3sec:SecondCandySET()
	if (self:IsCandyBarRegistered("GCDBAR")) then
		self:StopCandyBar("GCDBAR");
		self:UnregisterCandyBar("GCDBAR");
	end
	if (wf3sec.db.profile.showgcd and self.gcdid) then
--		if (self.gcdid) then
			self:RegisterCandyBar("GCDBAR",1.5,"GCD",self.gcdtexture);
			self:SetCandyBarColor("GCDBAR","white",0.5);
			self:SetCandyBarScale("GCDBAR", wf3sec.db.profile.scalegcd);
			self:RegisterCandyBarWithGroup("GCDBAR","SecondCandy");
--		end
	end
end

function wf3sec:SScandySET()
	if (self:IsCandyBarRegistered("SScandyBAR")) then
		self:StopCandyBar("SScandyBAR");
		self:UnregisterCandyBar("SScandyBAR");
	end
	if (wf3sec.db.profile.showss and self.ssid) then
--		if (self.ssid) then
			self:RegisterCandyBar("SScandyBAR",10,"Stormstrike",self.sstexture);
			self:SetCandyBarColor("SScandyBAR","green",0.5);
			self:SetCandyBarScale("SScandyBAR", wf3sec.db.profile.scale);
			self:RegisterCandyBarWithGroup("SScandyBAR","MainCandy");
--		end
	end
end

function wf3sec:MTcandySET()
	if (self:IsCandyBarRegistered("MTcandyBAR")) then
		self:StopCandyBar("MTcandyBAR");
		self:UnregisterCandyBar("MTcandyBAR");
	end
	if (wf3sec.db.profile.showmt and self.mtid) then
		self:RegisterCandyBar("MTcandyBAR",20,"MT",self.mttexture);
		self:SetCandyBarColor("MTcandyBAR","cyan",0.5);
		self:SetCandyBarScale("MTcandyBAR", wf3sec.db.profile.scale);
		self:RegisterCandyBarWithGroup("MTcandyBAR","MainCandy");
	end
end

function wf3sec:FeralcandySET()
	if (self:IsCandyBarRegistered("FeralcandyBAR")) then
		self:StopCandyBar("FeralcandyBAR");
		self:UnregisterCandyBar("FeralcandyBAR");
	end
	if (wf3sec.db.profile.showferal and self.feralid) then
--		if (self.ssid) then
			self:RegisterCandyBar("FeralcandyBAR",(3*60),"Feral",self.feraltexture);
			self:SetCandyBarColor("FeralcandyBAR","magenta",0.2);
			self:SetCandyBarScale("FeralcandyBAR", wf3sec.db.profile.scale);
			self:RegisterCandyBarWithGroup("FeralcandyBAR","MainCandy");
--		end
	end
end

function wf3sec:LLcandySET()
	if (self:IsCandyBarRegistered("LLcandyBAR")) then
		self:StopCandyBar("LLcandyBAR");
		self:UnregisterCandyBar("LLcandyBAR");
	end
	if (wf3sec.db.profile.showll and self.llid) then
--		if (self.llid) then
		if (wf3sec.db.profile.tensec) then
			self:RegisterCandyBar("LLcandyBAR",10,"Lava Lash",self.lltexture);
		else
			self:RegisterCandyBar("LLcandyBAR",6,"Lava Lash",self.lltexture);
		end
		self:SetCandyBarColor("LLcandyBAR","red",0.5);
		self:SetCandyBarScale("LLcandyBAR", wf3sec.db.profile.scale);
		self:RegisterCandyBarWithGroup("LLcandyBAR","MainCandy");
--		end
	end
end

function wf3sec:SRcandySET()
	if (self:IsCandyBarRegistered("SRcandyBAR")) then
		self:StopCandyBar("SRcandyBAR");
		self:UnregisterCandyBar("SRcandyBAR");
	end
	if (wf3sec.db.profile.showsr and self.srid) then
--		if (self.srid) then
			self:RegisterCandyBar("SRcandyBAR",120,"Rage",self.srtexture);
			self:SetCandyBarColor("SRcandyBAR","orange",0.5);
			self:SetCandyBarScale("SRcandyBAR", wf3sec.db.profile.scale);
			self:RegisterCandyBarWithGroup("SRcandyBAR","MainCandy");
--		end
--[[	else
		if (self:IsCandyBarRegistered("SRcandyBAR")) then
			self:UnregisterCandyBar("SRcandyBAR");
		end--]]
	end
end

function wf3sec:ShockcandySET()
	if (self:IsCandyBarRegistered("ShockcandyBAR")) then
		self:StopCandyBar("ShockcandyBAR");
		self:UnregisterCandyBar("ShockcandyBAR");
	end
	if (wf3sec.db.profile.showshock and self.esid) then
--		if (self.esid) then
			if (wf3sec.db.profile.tensec) then
				self:RegisterCandyBar("ShockcandyBAR",10,"Shock",self.estexture);
			else
				self:RegisterCandyBar("ShockcandyBAR",6,"Shock",self.estexture);
			end
			self:SetCandyBarColor("ShockcandyBAR","yellow",0.5);
			self:SetCandyBarScale("ShockcandyBAR", wf3sec.db.profile.scale);
			self:RegisterCandyBarWithGroup("ShockcandyBAR","MainCandy");
--		end
	end
end

function wf3sec:FlamecandySET()
	if (self:IsCandyBarRegistered("FlamecandyBAR")) then
		self:StopCandyBar("FlamecandyBAR");
		self:UnregisterCandyBar("FlamecandyBAR");
	end
	if (wf3sec.db.profile.showshock and self.fsid) then
--		if (self.fsid) then
			self:RegisterCandyBar("FlamecandyBAR",12,"Flame",self.fstexture);
			self:SetCandyBarColor("FlamecandyBAR","red",0.3);
			self:SetCandyBarScale("FlamecandyBAR", wf3sec.db.profile.scalegcd);
			self:RegisterCandyBarWithGroup("FlamecandyBAR","SecondCandy");
--		end
	end
end

function wf3sec:SSdcandySET()
	if (self:IsCandyBarRegistered("SSdcandyBAR")) then
		self:StopCandyBar("SSdcandyBAR");
		self:UnregisterCandyBar("SSdcandyBAR");
	end
	if (wf3sec.db.profile.showss and self.ssid) then
--		if (self.ssid) then
			self:RegisterCandyBar("SSdcandyBAR",12,"SS",self.sstexture);
			self:SetCandyBarColor("SSdcandyBAR","green",0.3);
			self:SetCandyBarScale("SSdcandyBAR", wf3sec.db.profile.scalegcd);
			self:RegisterCandyBarWithGroup("SSdcandyBAR","SecondCandy");
--		end
	end
end

--[[function wf3sec:ACTIONBAR_UPDATE_STATE()
	if (self.ssid) then
		local ssstart, ssduration, ssenabled = GetSpellCooldown(self.ssid,BOOKTYPE_SPELL);
		local sec = GetTime();
		DEFAULT_CHAT_FRAME:AddMessage(sec.." "..ssstart.." "..ssduration.." "..ssenabled.." "..(sec-ssstart));
	end
end--]]

-- /script wf3sec:DPSFrame();
function wf3sec:ACTIONBAR_UPDATE_COOLDOWN()
--	self:DPSFrameUpdate();
	local ssstart, ssduration, ssenabled = GetSpellCooldown(self.gcdid,BOOKTYPE_SPELL);
	if (wf3sec.db.profile.showgcd) then
		if (ssenabled and ssstart>1 and ssduration>0.9) then
			local sstimeleft=ssduration - (GetTime() - ssstart);
			self:StopCandyBar("GCDBAR");
			self:SetCandyBarTimeLeft("GCDBAR",sstimeleft);
			self:StartCandyBar("GCDBAR");
		end
	end
	
	if (self.ssid) then
		if (wf3sec.db.profile.showss) then
			local ssstart, ssduration, ssenabled = GetSpellCooldown(self.ssid,BOOKTYPE_SPELL);
			if (ssenabled and ssstart>1 and ssduration>0.9) then
				local sstimeleft=ssduration - (GetTime() - ssstart);
				local reg, t, e, r = self:CandyBarStatus("SScandyBAR");
				if ((not r) or (sstimeleft>(t-e))) then
					self:StopCandyBar("SScandyBAR");
					self:SetCandyBarTimeLeft("SScandyBAR",sstimeleft);
					self:StartCandyBar("SScandyBAR");
				end
			end
		end
	end
	if (self.llid) then
		if (wf3sec.db.profile.showll) then
			local ssstart, ssduration, ssenabled = GetSpellCooldown(self.llid,BOOKTYPE_SPELL);
			if (ssenabled and ssstart>1 and ssduration>0.9) then
				local sstimeleft=ssduration - (GetTime() - ssstart);
				local reg, t, e, r = self:CandyBarStatus("LLcandyBAR");
				if ((not r) or (sstimeleft>(t-e))) then
					self:StopCandyBar("LLcandyBAR");
					self:SetCandyBarTimeLeft("LLcandyBAR",sstimeleft);
					self:StartCandyBar("LLcandyBAR");
				end
			end
		end
	end
	if (wf3sec.db.profile.showshock) then
		local ssstart, ssduration, ssenabled = GetSpellCooldown(self.esid,BOOKTYPE_SPELL);
		if (ssenabled and ssstart>1 and ssduration>0.9) then
			local sstimeleft=ssduration - (GetTime() - ssstart);
			self:StopCandyBar("ShockcandyBAR");
			self:SetCandyBarTimeLeft("ShockcandyBAR",sstimeleft);
			self:StartCandyBar("ShockcandyBAR");
		end
	end
	if (wf3sec.db.profile.showferal and self.feralid) then
		local ssstart, ssduration, ssenabled = GetSpellCooldown(self.feralid,BOOKTYPE_SPELL);
		if (ssenabled and ssstart>1 and ssduration>1.5) then
			local sstimeleft=ssduration - (GetTime() - ssstart);
			if (sstimeleft==180) then
				self:StopCandyBar("FeralcandyBAR");
				self:SetCandyBarColor("FeralcandyBAR","blue",0.5);
				self:SetCandyBarTime("FeralcandyBAR",45);
				self:SetCandyBarTimeLeft("FeralcandyBAR",45);
				self:StartCandyBar("FeralcandyBAR");
			end
			if (sstimeleft<=(180-45)) then
				self:StopCandyBar("FeralcandyBAR");
				self:SetCandyBarColor("FeralcandyBAR","magenta",0.2);
				self:SetCandyBarTime("FeralcandyBAR",(3*60));
				self:SetCandyBarTimeLeft("FeralcandyBAR",sstimeleft);
				self:StartCandyBar("FeralcandyBAR");
			end
--			DEFAULT_CHAT_FRAME:AddMessage(ssstart.." "..ssduration.." "..ssenabled.." "..sstimeleft);
		end
	end
	if (wf3sec.db.profile.showsr) then
		local ssstart, ssduration, ssenabled = GetSpellCooldown(self.srid,BOOKTYPE_SPELL);
		if (ssenabled and ssstart>1 and ssduration>1.5) then
			local sstimeleft=ssduration - (GetTime() - ssstart);
			self:StopCandyBar("SRcandyBAR");
			self:SetCandyBarTimeLeft("SRcandyBAR",sstimeleft);
			self:StartCandyBar("SRcandyBAR");
		end
	end
end

function wf3sec:COMBAT_LOG_EVENT_UNFILTERED(...)
-- wf3sec:DPSFrameUpdate();
--	local timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, _, spname = select(1, ...) or "nil";
local srcName = select(4, ...);

--	local message = format("%s> %s, %s, %s, %s, %s, %s, %s",
--	                       timestamp, eventtype,
--	                       srcGUID, srcName or "nil", srcFlags or "nil",
--	                       dstGUID, dstName or "nil", dstFlags or "nil");
--	for i = 9, select("#", ...) do
--		message = message..", "..(select(i, ...) or "nil");
--	end
	if (srcName==playerName) then
		local spName = select(10, ...) or "nil";
		if (spName==L["Magma Totem"]) then
			local eventtype=select(2, ...)
			if (eventtype=="SPELL_SUMMON") then
				self:StopCandyBar("MTcandyBAR");
				self:SetCandyBarTimeLeft("MTcandyBAR",20);
				self:StartCandyBar("MTcandyBAR");
			end
		end
	end
	if (srcName==playerName) then
	local spName = select(10, ...) or "nil";
	local eventtype = select(2, ...) or "nil";
	if (spName==L["Stormstrike"] and eventtype=="SPELL_DAMAGE") then
		local seconds = GetTime();
		if (seconds<(self.lastwf+3) and (seconds-self.lastss)>1) then
			self.lostss=self.lostss+1;
			self.lastss=seconds;
		end
	end
	if (spName==L["Windfury Attack"]) then
		local seconds = GetTime();
		local down, up, lag = GetNetStats();
			if ((seconds-self.lastwf)>1) then
				self.numwf=self.numwf+1;
				if (wf3sec.db.profile.showwf and self.wfid) then
					self:StopCandyBar("WFcandyBAR");
					self:SetCandyBarTimeLeft("WFcandyBAR",(3-lag/1000));
					self:StartCandyBar("WFcandyBAR");
				else
					if (wf3sec.db.profile.showss and self.ssid) then
						local reg, t, e, r = self:CandyBarStatus("SScandyBAR");
						if ((r and (t-e)<(3-lag/1000)) or (not r)) then
							self:StopCandyBar("SScandyBAR");
							self:SetCandyBarTimeLeft("SScandyBAR",(3-lag/1000));
							self:StartCandyBar("SScandyBAR");
						end
					end
				end			
			end
			self.lastwf=seconds-lag/1000;
--		DEFAULT_CHAT_FRAME:AddMessage(srcName.." "..spName);
		end
	end
--[[	if (spName==L["Feral Spirit"]) then
		DEFAULT_CHAT_FRAME:AddMessage(srcName.." "..spName);
	end--]]
end

--[[function wf3sec:setoptions()
end--]]


function wf3sec:regMW()
		self:RegisterEvent("UNIT_AURA","BuffChange");
		self:RegisterEvent("PLAYER_AURAS_CHANGED","BuffChange");
		self:RegisterEvent("PLAYER_TARGET_CHANGED","Debuffs");
	if (release==3) then
		self:MWFrameSET();
	end
end

function wf3sec:ShieldFrameSET()
--	if (self.showmw) then
		if (not wf3sec.sf) then
			wf3sec.sf = CreateFrame("MessageFrame","MSFrame",UIParent)
			wf3sec.sf:SetFrameStrata("BACKGROUND")
			wf3sec.sf:SetWidth(30); 
			wf3sec.sf:SetHeight(30);
			wf3sec.sf:SetInsertMode("TOP");
--	local t = f:CreateTexture(nil,"BACKGROUND")
--	t:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Factions.blp")
--	t:SetAllPoints(f)
--	f.texture = t
			wf3sec.sf:SetPoint("CENTER", "UIParent", "CENTER",wf3sec.db.profile.xs,wf3sec.db.profile.ys)
			wf3sec.sf:SetTimeVisible(9999999999);
			wf3sec.sf:SetFontObject(GameFontRedLarge);
		end
		if (wf3sec.db.profile.showshield) then
			wf3sec.sf:Show();
		else
			wf3sec.sf:Hide();
		end
--		
--	else
--		if (wf3sec.f) then wf3sec.f:Hide(); end
--	end
end

function wf3sec:MWFrameSET()
--	if (self.showmw) then
		if (not wf3sec.f) then
			wf3sec.f = CreateFrame("MessageFrame","MSFrame",UIParent)
			wf3sec.f:SetFrameStrata("BACKGROUND")
			wf3sec.f:SetWidth(30); 
			wf3sec.f:SetHeight(30);
			wf3sec.f:SetInsertMode("TOP");
--	local t = f:CreateTexture(nil,"BACKGROUND")
--	t:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Factions.blp")
--	t:SetAllPoints(f)
--	f.texture = t
			wf3sec.f:SetPoint("CENTER", "UIParent", "CENTER",wf3sec.db.profile.xmw,wf3sec.db.profile.ymw)
			wf3sec.f:SetTimeVisible(9999999999);
			wf3sec.f:SetFontObject(GameFontRedLarge);
		end
		if (wf3sec.db.profile.showmw) then
			wf3sec.f:Show();
		else
			wf3sec.f:Hide();
		end
--		
--	else
--		if (wf3sec.f) then wf3sec.f:Hide(); end
--	end
end

function wf3sec:TestMW()
	if (wf3sec.f) then MSFrame:AddMessage("*",1,0,1); end
end

function wf3sec:BuffChange()
	if ((not arg1) or (arg1=="player")) then
		if (release==3) then
			if (UnitBuff("player",L["Maelstrom Weapon"])) then
				local name, rank, icon, count, debuffType, duration, expirationTime, isMine = UnitBuff("player", L["Maelstrom Weapon"]);
				MSFrame:AddMessage(count,1,0,1);
			else
				MSFrame:AddMessage(" ",1,0,1);
			end
		end
	end
	if (arg1=="target")then
		wf3sec:Debuffs();
	end
		
end

function wf3sec:Debuffs()
	local flame=nil;
	local ss=nil;
	if (release==3) then
		if (UnitDebuff("target",L["Flame Shock"]) and wf3sec.db.profile.showshock and self.fsid) then
			local name, rank, icon, count, debuffType, duration, expirationTime, isMine = UnitDebuff("target", L["Flame Shock"]);
			if (isMine==1) then
				local seconds = GetTime();
				flame=(expirationTime-seconds);
				self:StopCandyBar("FlamecandyBAR");
				self:SetCandyBarTimeLeft("FlamecandyBAR",flame);
				self:StartCandyBar("FlamecandyBAR");
--				DEFAULT_CHAT_FRAME:AddMessage("Flame "..duration.." "..expirationTime.." "..seconds);
			end
		end
		
		if (UnitDebuff("target",L["Stormstrike"]) and wf3sec.db.profile.showss and self.ssid) then
			local name, rank, icon, count, debuffType, duration, expirationTime, isMine = UnitDebuff("target", L["Stormstrike"]);
			if (isMine==1) then
				local seconds = GetTime();
				ss=(expirationTime-seconds);
				self:StopCandyBar("SSdcandyBAR");
				self:SetCandyBarTimeLeft("SSdcandyBAR",ss);
				self:StartCandyBar("SSdcandyBAR");
			end
		end
	else
		for i=1,40 do 
			local name, rank, icon, count, debuffType, duration, expirationTime = UnitDebuff("target", i);
			if (name==L["Flame Shock"] and duration and wf3sec.db.profile.showshock and self.fsid) then
				local seconds = GetTime();
				self:StopCandyBar("FlamecandyBAR");
				self:SetCandyBarTimeLeft("FlamecandyBAR",expirationTime);
				self:StartCandyBar("FlamecandyBAR");
				flame=expirationTime;
			end
			if (name==L["Stormstrike"] and duration and wf3sec.db.profile.showss and self.ssid) then
				local seconds = GetTime();
				self:StopCandyBar("SSdcandyBAR");
				self:SetCandyBarTimeLeft("SSdcandyBAR",expirationTime);
				self:StartCandyBar("SSdcandyBAR");
				ss=expirationTime;
			end
		end
	end
	if (not flame) then
		self:StopCandyBar("FlamecandyBAR");
	end
	if (not ss) then
		self:StopCandyBar("SSdcandyBAR");
	end
--	DEFAULT_CHAT_FRAME:AddMessage(flame.." "..ss);
	return flame, ss;
end

--[[function wf3sec:showMS()
-- local index = 1
-- while GetPlayerBuff(index, "HELPFUL")>0 do
--	local buffid = GetPlayerBuff(index, "HELPFUL")
--	MSFrame:AddMessage(buffid,1,1,1);
--	index=index+1;
--	end
-- for i=1,32 do

	
end--]]

-- /script wf3sec:DPSFrame();
--[[function wf3sec:DPSFrame()
	self:RegisterEvent("DPSFrameUpdate");
	if (not self.dpsf) then
		self.dpsf = CreateFrame("Frame",nil,UIParent)
		self.dpsf:SetFrameStrata("BACKGROUND")
		self.dpsf:SetWidth(40) -- Set these to whatever height/width is needed 
		self.dpsf:SetHeight(40) -- for your Texture
		self.dpsf.texture=self.dpsf:CreateTexture(nil,"BACKGROUND");
		self.dpsf.texture:SetTexture(self.fstexture);
		self.dpsf.texture:SetDesaturated(1);
		self.dpsf.texture:SetAllPoints(self.dpsf);
		self.dpsf:SetPoint("CENTER",70,200)
		self.dpsf:Show()
	end
end

function wf3sec:cDPSFrame(text,dis)
	if (self.dpsf) then
		self.dpsf:Hide();
		self.dpsf.texture:SetTexture(text);
		self.dpsf.texture:SetDesaturated(dis);
		self.dpsf.texture:SetAllPoints(self.dpsf);
		self.dpsf:Show();
	end
end

function wf3sec:DPSFrameUpdate()
	local sec = GetTime();
	local sstime;
	if (self.ssid) then
		local ssstart, ssduration, ssenabled = GetSpellCooldown(self.ssid,BOOKTYPE_SPELL);
--		DEFAULT_CHAT_FRAME:AddMessage(sec.." "..ssstart.." "..ssduration.." "..ssenabled.." "..(ssstart+ssduration-sec));
		if (ssstart>0) then
			wf3sec:cDPSFrame(wf3sec.sstexture,1);
			sstime=(ssstart+ssduration-sec);
			wf3sec:ScheduleEvent("DPSFrameUpdate",(sstime-1.5));
			wf3sec:ScheduleEvent("DPSFrameUpdate",sstime);
		else
			if ((sec-self.lastwf)<3) then
				wf3sec:cDPSFrame(wf3sec.sstexture,1);
				wf3sec:ScheduleEvent("DPSFrameUpdate",(sec-self.lastwf));
				sstime=(sec-self.lastwf);
				if ((sec-self.lastwf)<1.5) then
					return;
				end
			else
				wf3sec:cDPSFrame(wf3sec.sstexture);
				return;
			end
		end
	end
	if (self.fsid) then
		local flame=wf3sec:Debuffs();
--		DEFAULT_CHAT_FRAME:AddMessage(flame);
		local fsstart, fsduration, fsenabled = GetSpellCooldown(self.fsid,BOOKTYPE_SPELL);
		if (fsstart>0) then
			if ((sstime-(fsstart+fsduration-sec))>=1.5) then
				wf3sec:cDPSFrame(wf3sec.fstexture,1);
				wf3sec:ScheduleEvent("DPSFrameUpdate",(fsstart+fsduration-sec));
			end
--			wf3sec:cDPSFrame(wf3sec.sstexture,1);
--			
		else
			if (not flame) then
				wf3sec:cDPSFrame(wf3sec.fstexture);
				return;
			else
				wf3sec:cDPSFrame(wf3sec.estexture);
				return;
			end
		end
	end
end--]]
